ViewVC Help
View File | Revision Log | Show Annotations | Download File
/cvs/App-Staticperl/staticperl.sh
(Generate patch)

Comparing App-Staticperl/staticperl.sh (file contents):
Revision 1.6 by root, Tue Dec 7 10:40:39 2010 UTC vs.
Revision 1.24 by root, Wed Dec 22 01:23:38 2010 UTC

2 2
3############################################################################# 3#############################################################################
4# configuration to fill in 4# configuration to fill in
5 5
6STATICPERL=~/.staticperl 6STATICPERL=~/.staticperl
7CPAN=http://mirror.netcologne.de/cpan/ # which mirror to use 7CPAN=http://mirror.netcologne.de/cpan # which mirror to use
8EMAIL="read the documentation <rtfm@example.org>" 8EMAIL="read the documentation <rtfm@example.org>"
9 9
10MKBUNDLE="$STATICPERL/mkbundle"
11
12# perl build variables 10# perl build variables
13PERL_PREFIX="$STATICPERL/perl" # where the perl gets installed 11MAKE=make
14PERL_VERSION=5.12.2 # 5.8.9 is also a good choice 12PERL_VERSION=5.12.2 # 5.8.9 is also a good choice
13PERL_CC=cc
15PERL_CONFIGURE="" # additional Configure arguments 14PERL_CONFIGURE="" # additional Configure arguments
16PERL_CPPFLAGS="-DPERL_DISABLE_PMC -DPERL_ARENA_SIZE=65536 -D_GNU_SOURCE -DNDEBUG -USITELIB_EXP -USITEARCHEXP -UARCHLIB_EXP" 15PERL_CCFLAGS="-DPERL_DISABLE_PMC -DPERL_ARENA_SIZE=65536 -D_GNU_SOURCE -DNDEBUG"
17PERL_OPTIMIZE="-Os -ffunction-sections -fdata-sections -finline-limit=8 -ffast-math" 16PERL_OPTIMIZE="-Os -ffunction-sections -fdata-sections -finline-limit=8 -ffast-math"
18 17
19ARCH="$(uname -m)" 18ARCH="$(uname -m)"
20 19
21case "$ARCH" in 20case "$ARCH" in
29 ;; 28 ;;
30esac 29esac
31 30
32# -Wl,--gc-sections makes it impossible to check for undefined references 31# -Wl,--gc-sections makes it impossible to check for undefined references
33# for some reason so we need to patch away the "-no" after Configure and before make :/ 32# for some reason so we need to patch away the "-no" after Configure and before make :/
34# -z muldefs is to work around uclibc's pthread static linking bug 33# --allow-multiple-definition exists to work around uclibc's pthread static linking bug
35PERL_LDFLAGS="-Wl,--no-gc-sections -z muldefs" 34PERL_LDFLAGS="-Wl,--no-gc-sections -Wl,--allow-multiple-definition"
36PERL_LIBS="-lm -lcrypt" # perl loves to add lotsa crap itself 35PERL_LIBS="-lm -lcrypt" # perl loves to add lotsa crap itself
37 36
38# some configuration options for modules 37# some configuration options for modules
39export PERL_MM_USE_DEFAULT=1 38PERL_MM_USE_DEFAULT=1
40#export CORO_INTERFACE=p # needed without nptl on x86, due to bugs in linuxthreads - very slow 39#CORO_INTERFACE=p # needed without nptl on x86, due to bugs in linuxthreads - very slow
41export EV_EXTRA_DEFS='-DEV_FEATURES=4+8+16+64 -DEV_USE_SELECT=0 -DEV_USE_POLL=1 -DEV_USE_EPOLL=1 -DEV_NO_LOOPS -DEV_COMPAT3=0' 40EV_EXTRA_DEFS='-DEV_FEATURES=4+8+16+64 -DEV_USE_SELECT=0 -DEV_USE_POLL=1 -DEV_USE_EPOLL=1 -DEV_NO_LOOPS -DEV_COMPAT3=0'
41export PERL_MM_USE_DEFAULT CORO_INTERFACE EV_EXTRA_DEFS
42 42
43# which extra modules to install by default from CPAN that are 43# which extra modules to install by default from CPAN that are
44# required by mkbundle 44# required by mkbundle
45STATICPERL_MODULES="common::sense Pod::Strip PPI::XS Pod::Usage" 45STATICPERL_MODULES="common::sense Pod::Strip PPI::XS Pod::Usage"
46 46
47# which extra modules you might want to install 47# which extra modules you might want to install
48EXTRA_MODULES="" 48EXTRA_MODULES=""
49 49
50# overridable functions 50# overridable functions
51preconfigure() { : ; }
51postconfigure() { : ; } 52postconfigure() { : ; }
52postbuild() { : ; } 53postbuild() { : ; }
53postinstall() { : ; } 54postinstall() { : ; }
54 55
55# now source user config, if any 56# now source user config, if any
57if [ "$STATICPERLRC" ]; then
58 . "$STATICPERLRC"
59else
56[ -r /etc/staticperlrc ] && . /etc/staticperlrc 60 [ -r /etc/staticperlrc ] && . /etc/staticperlrc
57[ -r ~/.staticperlrc ] && . ~/.staticperlrc 61 [ -r ~/.staticperlrc ] && . ~/.staticperlrc
58[ -r "$STATICPERL/rc" ] && . "$STATICPERL/rc" 62 [ -r "$STATICPERL/rc" ] && . "$STATICPERL/rc"
63fi
59 64
60############################################################################# 65#############################################################################
61# support 66# support
67
68MKBUNDLE="${MKBUNDLE:=$STATICPERL/mkbundle}"
69PERL_PREFIX="${PERL_PREFIX:=$STATICPERL/perl}" # where the perl gets installed
70
71unset PERL5OPT PERL5LIB PERLLIB PERL_UNICODE PERLIO_DEBUG
72LC_ALL=C; export LC_ALL # just to be on the safe side
62 73
63# set version in a way that Makefile.PL can extract 74# set version in a way that Makefile.PL can extract
64VERSION=VERSION; eval \ 75VERSION=VERSION; eval \
65$VERSION=0.1 76$VERSION=0.92
66 77
67BZ2=bz2 78BZ2=bz2
68BZIP2=bzip2 79BZIP2=bzip2
69 80
70fatal() { 81fatal() {
103############################################################################# 114#############################################################################
104# clean 115# clean
105 116
106distclean() { 117distclean() {
107 verblock <<EOF 118 verblock <<EOF
108deleting everything installed by this script 119 deleting everything installed by this script (rm -rf $STATICPERL)
109EOF 120EOF
110 121
111 rm -rf "$STATICPERL" 122 rm -rf "$STATICPERL"
112} 123}
113 124
114############################################################################# 125#############################################################################
115# download/configure/compile/install perl 126# download/configure/compile/install perl
116 127
117clean() { 128clean() {
118 cd "$STATICPERL/src/perl-$PERL_VERSION" 2>/dev/null || return 129 rm -rf "$STATICPERL/src/perl-$PERL_VERSION"
130}
119 131
120 rm -f staticstamp.configure 132realclean() {
121 make distclean >/dev/null 2>&1 133 rm -f "$PERL_PREFIX/staticstamp.postinstall"
134 rm -f "$PERL_PREFIX/staticstamp.install"
135 rm -f "$STATICPERL/src/perl-"*"/staticstamp.configure"
122} 136}
123 137
124fetch() { 138fetch() {
125 rcd "$STATICPERL" 139 rcd "$STATICPERL"
126 140
141 155
142 rm -f perl-$PERL_VERSION.tar.$BZ2~ # just to be on the safe side 156 rm -f perl-$PERL_VERSION.tar.$BZ2~ # just to be on the safe side
143 wget -O perl-$PERL_VERSION.tar.$BZ2~ "$URL" \ 157 wget -O perl-$PERL_VERSION.tar.$BZ2~ "$URL" \
144 || curl >perl-$PERL_VERSION.tar.$BZ2~ "$URL" \ 158 || curl >perl-$PERL_VERSION.tar.$BZ2~ "$URL" \
145 || fatal "$URL: unable to download" 159 || fatal "$URL: unable to download"
160 rm -f perl-$PERL_VERSION.tar.$BZ2
146 mv perl-$PERL_VERSION.tar.$BZ2~ perl-$PERL_VERSION.tar.$BZ2 161 mv perl-$PERL_VERSION.tar.$BZ2~ perl-$PERL_VERSION.tar.$BZ2
147 fi 162 fi
148 163
149 verblock <<EOF 164 verblock <<EOF
150unpacking perl 165unpacking perl
151EOF 166EOF
152 167
153 mkdir -p unpack 168 mkdir -p unpack
169 rm -rf unpack/perl-$PERL_VERSION
154 $BZIP2 -d <perl-$PERL_VERSION.tar.bz2 | tar xpC unpack \ 170 $BZIP2 -d <perl-$PERL_VERSION.tar.bz2 | tar xfC - unpack \
155 || fatal "perl-$PERL_VERSION.tar.bz2: error during unpacking" 171 || fatal "perl-$PERL_VERSION.tar.bz2: error during unpacking"
172 chmod -R u+w unpack/perl-$PERL_VERSION
156 mv unpack/perl-$PERL_VERSION perl-$PERL_VERSION 173 mv unpack/perl-$PERL_VERSION perl-$PERL_VERSION
157 rmdir -p unpack 174 rmdir -p unpack
158 fi 175 fi
159} 176}
160 177
161# similar to GNU-sed -i or perl -pi 178# similar to GNU-sed -i or perl -pi
162sedreplace() { 179sedreplace() {
163 sed -e "$1" <"$2" > "$2~" || fatal "error while running sed" 180 sed -e "$1" <"$2" > "$2~" || fatal "error while running sed"
181 rm -f "$2"
164 mv "$2~" "$2" 182 mv "$2~" "$2"
183}
184
185configure_failure() {
186 cat <<EOF
187
188
189***
190*** Configure failed - see above for the exact error message(s).
191***
192*** Most commonly, this is because the default PERL_CCFLAGS or PERL_OPTIMIZE
193*** flags are not supported by your compiler. Less often, this is because
194*** PERL_LIBS either contains a library not available on your system (such as
195*** -lcrypt), or because it lacks a required library (e.g. -lsocket or -lnsl).
196***
197*** You can provide your own flags by creating a ~/.staticperlrc file with
198*** variable assignments. For example (these are the actual values used):
199***
200
201PERL_CC="$PERL_CC"
202PERL_CCFLAGS="$PERL_CCFLAGS"
203PERL_OPTIMIZE="$PERL_OPTIMIZE"
204PERL_LDFLAGS="$PERL_LDFLAGS"
205PERL_LIBS="$PERL_LIBS"
206
207EOF
208 exit 1
165} 209}
166 210
167configure() { 211configure() {
168 fetch 212 fetch
169 213
173 217
174 verblock <<EOF 218 verblock <<EOF
175configuring $STATICPERL/src/perl-$PERL_VERSION 219configuring $STATICPERL/src/perl-$PERL_VERSION
176EOF 220EOF
177 221
178 clean
179
180 rm -f "$PERL_PREFIX/staticstamp.install" 222 rm -f "$PERL_PREFIX/staticstamp.install"
181 223
224 "$MAKE" distclean >/dev/null 2>&1
225
226 sedreplace '/^#define SITELIB/d' config_h.SH
227
182 # I hate them 228 # I hate them for this
183 grep -q -- -fstack-protector Configure && \ 229 grep -q -- -fstack-protector Configure && \
184 sedreplace 's/-fstack-protector/-fno-stack-protector/g' Configure 230 sedreplace 's/-fstack-protector/-fno-stack-protector/g' Configure
231
232 preconfigure
185 233
186# trace configure \ 234# trace configure \
187 sh Configure -Duselargefiles \ 235 sh Configure -Duselargefiles \
188 -Uuse64bitint \ 236 -Uuse64bitint \
189 -Dusemymalloc=n \ 237 -Dusemymalloc=n \
190 -Uusedl \ 238 -Uusedl \
191 -Uusethreads \ 239 -Uusethreads \
192 -Uuseithreads \ 240 -Uuseithreads \
193 -Uusemultiplicity \ 241 -Uusemultiplicity \
194 -Duseperlio \
195 -Uusesfio \ 242 -Uusesfio \
196 -Uuseshrplib \ 243 -Uuseshrplib \
197 -Dcppflags="$PERL_CPPFLAGS" \ 244 -A ccflags=" $PERL_CCFLAGS" \
198 -Dccflags="-g2 -fno-strict-aliasing" \ 245 -Dcc="$PERL_CC" \
199 -Doptimize="$PERL_OPTIMIZE" \ 246 -Doptimize="$PERL_OPTIMIZE" \
200 -Dldflags="$PERL_LDFLAGS" \ 247 -Dldflags="$PERL_LDFLAGS" \
201 -Dlibs="$PERL_LIBS" \ 248 -Dlibs="$PERL_LIBS" \
202 -Dprefix="$PERL_PREFIX" \ 249 -Dprefix="$PERL_PREFIX" \
203 -Dbin="$PERL_PREFIX/bin" \ 250 -Dbin="$PERL_PREFIX/bin" \
204 -Dprivlib="$PERL_PREFIX/lib" \ 251 -Dprivlib="$PERL_PREFIX/lib" \
205 -Darchlib="$PERL_PREFIX/lib" \ 252 -Darchlib="$PERL_PREFIX/lib" \
206 -Uusevendorprefix \ 253 -Uusevendorprefix \
207 -Dsitelib="$PERL_PREFIX/lib" \ 254 -Dsitelib="$PERL_PREFIX/lib" \
208 -Dsitearch="$PERL_PREFIX/lib" \ 255 -Dsitearch="$PERL_PREFIX/lib" \
209 -Usitelibexp \
210 -Uman1dir \ 256 -Uman1dir \
211 -Uman3dir \ 257 -Uman3dir \
212 -Usiteman1dir \ 258 -Usiteman1dir \
213 -Usiteman3dir \ 259 -Usiteman3dir \
214 -Dpager=/usr/bin/less \ 260 -Dpager=/usr/bin/less \
215 -Demail="$EMAIL" \ 261 -Demail="$EMAIL" \
216 -Dcf_email="$EMAIL" \ 262 -Dcf_email="$EMAIL" \
217 -Dcf_by="$EMAIL" \ 263 -Dcf_by="$EMAIL" \
218 $PERL_CONFIGURE \ 264 $PERL_CONFIGURE \
265 -Duseperlio \
219 -dE || fatal "Configure failed" 266 -dE || configure_failure
220 267
221 sedreplace ' 268 sedreplace '
222 s/-Wl,--no-gc-sections/-Wl,--gc-sections/g 269 s/-Wl,--no-gc-sections/-Wl,--gc-sections/g
223 s/ *-fno-stack-protector */ /g 270 s/ *-fno-stack-protector */ /g
224 ' config.sh 271 ' config.sh
239building $STATICPERL/src/perl-$PERL_VERSION 286building $STATICPERL/src/perl-$PERL_VERSION
240EOF 287EOF
241 288
242 rm -f "$PERL_PREFIX/staticstamp.install" 289 rm -f "$PERL_PREFIX/staticstamp.install"
243 290
244 make || fatal "make: error while building perl" 291 "$MAKE" || fatal "make: error while building perl"
245 292
246 postbuild || fatal "postbuild hook failed" 293 postbuild || fatal "postbuild hook failed"
247} 294}
248 295
249install() { 296install() {
250 [ -e "$PERL_PREFIX/staticstamp.install" ] && return 297 if ! [ -e "$PERL_PREFIX/staticstamp.install" ]; then
251
252 build 298 build
253 299
254 verblock <<EOF 300 verblock <<EOF
255installing $STATICPERL/src/perl-$PERL_VERSION 301installing $STATICPERL/src/perl-$PERL_VERSION
256to $PERL_PREFIX 302to $PERL_PREFIX
257EOF 303EOF
258 304
259 rm -rf "$PERL_PREFIX" 305 ln -sf "perl/bin/" "$STATICPERL/bin"
260 306 ln -sf "perl/lib/" "$STATICPERL/lib"
307
308 ln -sf "$PERL_PREFIX" "$STATICPERL/perl" # might get overwritten
309 rm -rf "$PERL_PREFIX" # by this rm -rf
310
261 make install || fatal "make install: error while installing" 311 "$MAKE" install || fatal "make install: error while installing"
262 312
263 rcd "$PERL_PREFIX" 313 rcd "$PERL_PREFIX"
264 314
265 # create a "make install" replacement for CPAN 315 # create a "make install" replacement for CPAN
266 cat >"$PERL_PREFIX"/bin/cpan-make-install <<EOF 316 cat >"$PERL_PREFIX"/bin/cpan-make-install <<EOF
267make install UNINST=1 317"$MAKE" || exit
318
268if find blib/arch/auto -type f | grep -q -v .exists; then 319if find blib/arch/auto -type f | grep -q -v .exists; then
269 echo Probably an XS module, rebuilding perl 320 echo Probably an XS module, rebuilding perl
270 make perl 321 if "$MAKE" perl; then
322 mv perl "$PERL_PREFIX"/bin/perl~ \
271 rm -f "$PERL_PREFIX"/bin/perl 323 && rm -f "$PERL_PREFIX"/bin/perl \
272 make -f Makefile.aperl inst_perl 324 && mv "$PERL_PREFIX"/bin/perl~ "$PERL_PREFIX"/bin/perl
273 make -f Makefile.aperl map_clean 325 "$MAKE" -f Makefile.aperl map_clean
326 else
327 "$MAKE" -f Makefile.aperl map_clean
328 exit 1
329 fi
274fi 330fi
331
332"$MAKE" install UNINST=1
275EOF 333EOF
276 chmod 755 "$PERL_PREFIX"/bin/cpan-make-install 334 chmod 755 "$PERL_PREFIX"/bin/cpan-make-install
277 335
278 # trick CPAN into avoiding ~/.cpan completely 336 # trick CPAN into avoiding ~/.cpan completely
279 echo 1 >"$PERL_PREFIX/lib/CPAN/MyConfig.pm" 337 echo 1 >"$PERL_PREFIX/lib/CPAN/MyConfig.pm"
280 338
281 "$PERL_PREFIX"/bin/perl -MCPAN -e ' 339 "$PERL_PREFIX"/bin/perl -MCPAN -e '
282 CPAN::Shell->o (conf => urllist => push => "'"$CPAN"'"); 340 CPAN::Shell->o (conf => urllist => push => "'"$CPAN"'");
283 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan"); 341 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan");
284 CPAN::Shell->o (conf => q<init>); 342 CPAN::Shell->o (conf => q<init>);
285 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan"); 343 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan");
286 CPAN::Shell->o (conf => q<build_dir>, "'"$STATICPERL"'/cpan/build"); 344 CPAN::Shell->o (conf => q<build_dir>, "'"$STATICPERL"'/cpan/build");
287 CPAN::Shell->o (conf => q<prefs_dir>, "'"$STATICPERL"'/cpan/prefs"); 345 CPAN::Shell->o (conf => q<prefs_dir>, "'"$STATICPERL"'/cpan/prefs");
288 CPAN::Shell->o (conf => q<histfile> , "'"$STATICPERL"'/cpan/histfile"); 346 CPAN::Shell->o (conf => q<histfile> , "'"$STATICPERL"'/cpan/histfile");
289 CPAN::Shell->o (conf => q<keep_source_where>, "'"$STATICPERL"'/cpan/sources"); 347 CPAN::Shell->o (conf => q<keep_source_where>, "'"$STATICPERL"'/cpan/sources");
290 CPAN::Shell->o (conf => q<make_install_make_command>, "'"$PERL_PREFIX"'/bin/cpan-make-install"); 348 CPAN::Shell->o (conf => q<make_install_make_command>, "'"$PERL_PREFIX"'/bin/cpan-make-install");
291 CPAN::Shell->o (conf => q<prerequisites_policy>, q<follow>); 349 CPAN::Shell->o (conf => q<prerequisites_policy>, q<follow>);
292 CPAN::Shell->o (conf => q<build_requires_install_policy>, q<no>); 350 CPAN::Shell->o (conf => q<build_requires_install_policy>, q<no>);
293 CPAN::Shell->o (conf => q<commit>); 351 CPAN::Shell->o (conf => q<commit>);
294 ' || fatal "error while initialising CPAN" 352 ' || fatal "error while initialising CPAN"
295 353
354 touch "$PERL_PREFIX/staticstamp.install"
355 fi
356
357 if ! [ -e "$PERL_PREFIX/staticstamp.postinstall" ]; then
296 NOCHECK_INSTALL=+ 358 NOCHECK_INSTALL=+
297 instcpan $STATICPERL_MODULES 359 instcpan $STATICPERL_MODULES
298 [ $EXTRA_MODULES ] && instcpan $EXTRA_MODULES 360 [ $EXTRA_MODULES ] && instcpan $EXTRA_MODULES
299 361
300 postinstall || fatal "postinstall hook failed" 362 postinstall || fatal "postinstall hook failed"
301 363
302 touch "$PERL_PREFIX/staticstamp.install" 364 touch "$PERL_PREFIX/staticstamp.postinstall"
365 fi
303} 366}
304 367
305############################################################################# 368#############################################################################
306# install a module from CPAN 369# install a module from CPAN
307 370
334 for mod in "$@"; do 397 for mod in "$@"; do
335 echo 398 echo
336 echo $mod 399 echo $mod
337 ( 400 (
338 rcd $mod 401 rcd $mod
339 make -f Makefile.aperl map_clean >/dev/null 2>&1 402 "$MAKE" -f Makefile.aperl map_clean >/dev/null 2>&1
340 make distclean >/dev/null 2>&1 403 "$MAKE" distclean >/dev/null 2>&1
341 "$PERL_PREFIX"/bin/perl Makefile.PL || fatal "$mod: error running Makefile.PL" 404 "$PERL_PREFIX"/bin/perl Makefile.PL || fatal "$mod: error running Makefile.PL"
342 make || fatal "$mod: error building module" 405 "$MAKE" || fatal "$mod: error building module"
343 "$PERL_PREFIX"/bin/cpan-make-install || fatal "$mod: error installing module" 406 "$PERL_PREFIX"/bin/cpan-make-install || fatal "$mod: error installing module"
344 make distclean >/dev/null 2>&1 407 "$MAKE" distclean >/dev/null 2>&1
345 exit 0 408 exit 0
346 ) || exit $? 409 ) || exit $?
347 done 410 done
348} 411}
349 412
350############################################################################# 413#############################################################################
351# main 414# main
352 415
353podusage() { 416podusage() {
354 echo 417 echo
418
355 if [ -e "$PERL_PREFIX/bin/perl" ]; then 419 if [ -e "$PERL_PREFIX/bin/perl" ]; then
356 "$PERL_PREFIX/bin/perl" -MPod::Usage -e \ 420 "$PERL_PREFIX/bin/perl" -MPod::Usage -e \
357 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \ 421 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \
358 2>/dev/null && exit 422 2>/dev/null && exit
359 fi 423 fi
424
360 # try whatever perl we can find 425 # try whatever perl we can find
361 perl -MPod::Usage -e \ 426 perl -MPod::Usage -e \
362 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \ 427 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \
363 2>/dev/null && exit 428 2>/dev/null && exit
364 429
365 fatal "displaying documentation requires a working perl - try '$0 install' first" 430 fatal "displaying documentation requires a working perl - try '$0 install' to build one in a safe location"
366} 431}
367 432
368usage() { 433usage() {
369 podusage 0 434 podusage 0
370} 435}
380} 445}
381 446
382bundle() { 447bundle() {
383 catmkbundle >"$MKBUNDLE~" || fatal "$MKBUNDLE~: cannot create" 448 catmkbundle >"$MKBUNDLE~" || fatal "$MKBUNDLE~: cannot create"
384 chmod 755 "$MKBUNDLE~" && mv "$MKBUNDLE~" "$MKBUNDLE" 449 chmod 755 "$MKBUNDLE~" && mv "$MKBUNDLE~" "$MKBUNDLE"
450 CACHE="$STATICPERL/cache"
451 mkdir -p "$CACHE"
385 "$PERL_PREFIX/bin/perl" -- "$MKBUNDLE" "$@" 452 "$PERL_PREFIX/bin/perl" -- "$MKBUNDLE" --cache "$CACHE" "$@"
386} 453}
387 454
388if [ $# -gt 0 ]; then 455if [ $# -gt 0 ]; then
389 while [ $# -gt 0 ]; do 456 while [ $# -gt 0 ]; do
390 mkdir -p "$STATICPERL" || fatal "$STATICPERL: cannot create" 457 mkdir -p "$STATICPERL" || fatal "$STATICPERL: cannot create"
391 mkdir -p "$PERL_PREFIX" || fatal "$PERL_PREFIX: cannot create" 458 mkdir -p "$PERL_PREFIX" || fatal "$PERL_PREFIX: cannot create"
392 459
393 command="${1#--}"; shift 460 command="${1#--}"; shift
394 case "$command" in 461 case "$command" in
462 version )
463 echo "staticperl version $VERSION"
464 ;;
395 fetch | configure | build | install | clean | distclean) 465 fetch | configure | build | install | clean | realclean | distclean)
396 verblock <<EOF
397$command
398EOF
399 ( "$command" ) 466 ( "$command" ) || exit
400 ;; 467 ;;
401 instsrc ) 468 instsrc )
402 ( instsrc "$@" ) 469 ( instsrc "$@" ) || exit
403 exit 470 exit
404 ;; 471 ;;
405 instcpan ) 472 instcpan )
406 ( instcpan "$@" ) 473 ( instcpan "$@" ) || exit
407 exit 474 exit
408 ;; 475 ;;
409 cpan ) 476 cpan )
410 ( install ) 477 ( install ) || exit
411 "$PERL_PREFIX/bin/cpan" "$@" 478 "$PERL_PREFIX/bin/cpan" "$@"
412 exit 479 exit
413 ;; 480 ;;
414 mkbundle ) 481 mkbundle )
415 ( install ) 482 ( install ) || exit
416 bundle "$@" 483 bundle "$@"
417 exit 484 exit
418 ;; 485 ;;
419 mkperl ) 486 mkperl )
420 ( install ) 487 ( install ) || exit
421 bundle --perl "$@" 488 bundle --perl "$@"
489 exit
490 ;;
491 mkapp )
492 ( install ) || exit
493 bundle --app "$@"
422 exit 494 exit
423 ;; 495 ;;
424 help ) 496 help )
425 podusage 2 497 podusage 2
426 ;; 498 ;;

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines